unit uTextMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,
  // Units einbinden
  F2d_Core,
  F2d_Text;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    fx,fy,vx,vy:single;
    ts:TSize;
    Engine:TEngine;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses math;

const TheText = 'Hello World!';

procedure TForm1.FormCreate(Sender: TObject);
begin
  //Initialisieren von Zufallsgenerator und Engine
  Randomize;
  Engine:= TEngine.Create(false);
  Engine.Init(self);

  // Erstellen der Fonts. Statt der einzelnen Parameter knnte
  // auch ein TFont-Objekt von Delphi verwendet werden
  Engine.FontManager.AddFont('myfont','arial',60,[fsItalic]);
  Engine.FontManager.AddFont('small','arial',18,[]);

  // Variablen fr den Spring-Text...
  fx:= Engine.Width / 2;
  fy:= Engine.Height / 2;
  vx:= random(4)-8;
  // Textgre mit TextSize ermitteln
  ts:= Engine.FontManager.TextSize('myfont',TheText);
  ts.cx:= floor(ts.cx / 2);
  ts.cy:= floor(ts.cy / 2);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Engine.DoBegin;
    // Animation:
    //  am Rand?
    if (fx<ts.cx-vx) or (fx>Engine.Width-ts.cx-vx) then
      vx:= -vx;
    if (fy<ts.cy-vy) or (fy>Engine.Height-vy) then
      vy:= -vy
    else
      vy:= vy+0.3;
    //  bewegen
    fx:= fx+vx;
    fy:= fy+vy;

    // Font binden...
    Engine.FontManager.BindFont('myfont',clRed);
    // ...und schreiben (einzeilig)
    Engine.TextOut(fx,fy,TheText,true,true);

    // Font binden...
    Engine.FontManager.BindFont('small',clBlue);
    // ...und schreiben (mehrzeilig, immer mit #13 getrennt. #10 darf nicht drin sein!)
    Engine.TextOutMultiline(10,50,'FPS: '+FloatToStrF(Engine.FPS,ffFixed,15,2)+#13+
                                  #13+
                                  'Keys:'+#13+
                                  ' Esc  - Exit');
    // Farbe wechseln
    Engine.FontManager.BindFont('small',clGreen);
    // ...und schreiben (einzeilig, horizontal zentriert)
    Engine.TextOut(Engine.Width/2,50,'FEAR2D Demo,  (c) Martok',true);
  Engine.DoEnd;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // das bliche:
  if Key = VK_Escape then close;
end;

end.
